/***************************************************************************
*   Copyright (C) 2004 by  ͤ                                            *
*   tasuku@linux-life.net                                                 *
*                                                                         *
*   This program is free software; you can redistribute it and/or modify  *
*   it under the terms of the GNU General Public License as published by  *
*   the Free Software Foundation; either version 2 of the License, or     *
*   (at your option) any later version.                                   *
*                                                                         *
*   This program is distributed in the hope that it will be useful,       *
*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
*   GNU General Public License for more details.                          *
*                                                                         *
*   You should have received a copy of the GNU General Public License     *
*   along with this program; if not, write to the                         *
*   Free Software Foundation, Inc.,                                       *
*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
***************************************************************************/
#ifndef DICTIONARY_H
#define DICTIONARY_H

#include "word.h"
#include <klistview.h>
#include <qstring.h>
#include <qvaluelist.h>

class Dictionary : public QObject, public QValueList<Word>
{
	Q_OBJECT
public:
	enum DictionaryType
	{
		Canna = 0,
		Anthy,
		Pubdic,
		Dixchange,
	};
	static DictionaryType name2type( QString name ){
		if( name == "Canna" ){
			return Canna;
		}else if( name == "Anthy" ){
			return Anthy;
		}else if ( name == "Pubdic" ){
			return Pubdic;
		}else if ( name == "Dixchange" ){
			return Dixchange;
		}
		return Pubdic;
	}
//	virtual ~Dictionary() = 0;
	virtual QString name() = 0;
	virtual bool expand( KListView* lvw ) = 0;
	virtual bool save( KListView* lvw ) = 0;
	virtual DictionaryType type() =  0;
	virtual void rmdic() = 0;
/*
private slots:
	virtual void slotRemove() = 0;
	virtual void slotRemoved() = 0;
*/
signals:
	void deleted( bool blSuccess );
	void progress( int percent );
};

#endif //DICTIONARY_H
